package com.google.inject;

import java.lang.annotation.Retention;
import java.lang.annotation.Target;

import static java.lang.annotation.ElementType.TYPE;
import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * A pointer to the default implementation of a type.
 */
@Retention(RUNTIME)
@Target(TYPE)
public @interface ImplementedBy {

    /**
     * The implementation type.
     */
    Class<?> value();
}
