package com.google.inject.internal;

/**
 * Something that needs some delayed initialization, typically
 * a binding or internal factory that needs to be created & put
 * into the bindings map & then initialized later.
 */
interface DelayedInitialize {

    /**
     * Initializes this binding, throwing any errors if necessary.
     */
    void initialize(InjectorImpl injector, Errors errors) throws ErrorsException;

}
