package com.google.inject.internal;

import com.google.inject.BindingAnnotation;

import java.lang.annotation.Retention;

import static java.lang.annotation.RetentionPolicy.RUNTIME;

/**
 * An internal binding annotation applied to each element in a multibinding.
 * All elements are assigned a globally-unique id to allow different modules
 * to contribute multibindings independently.
 */
@Retention(RUNTIME)
@BindingAnnotation
@interface Element {

    String setName();

    int uniqueId();

    Type type();

    String keyType();

    enum Type {
        MAPBINDER,
        MULTIBINDER;
    }
}
