package com.google.inject.internal;

import com.google.inject.spi.ProvisionListenerBinding;
import com.google.inject.spi.TypeListenerBinding;

/**
 * Handles {@code Binder#bindListener} commands.
 */
final class ListenerBindingProcessor extends AbstractProcessor {

    ListenerBindingProcessor(Errors errors) {
        super(errors);
    }

    @Override
    public Boolean visit(TypeListenerBinding binding) {
        injector.getBindingData().addTypeListener(binding);
        return true;
    }

    @Override
    public Boolean visit(ProvisionListenerBinding binding) {
        injector.getBindingData().addProvisionListener(binding);
        return true;
    }
}
