package com.google.inject.spi;

/**
 * Listens for injections into instances of type {@code I}. Useful for performing further
 * injections, post-injection initialization, and more.
 */
public interface InjectionListener<I> {

    /**
     * Invoked by Guice after it injects the fields and methods of instance.
     *
     * @param injectee instance that Guice injected dependencies into
     */
    void afterInjection(I injectee);
}
