package com.google.inject.spi;

import com.google.inject.Provides;

/**
 * A visitor for the {@literal @}{@link Provides} bindings.
 * <p>
 * If your {@link BindingTargetVisitor} implements this interface, bindings created by using
 * {@code @Provides} will be visited through this interface.
 */
public interface ProvidesMethodTargetVisitor<T, V> extends BindingTargetVisitor<T, V> {

    /**
     * Visits an {@link ProvidesMethodBinding} created with an {@literal @}{@link Provides} method.
     */
    V visit(ProvidesMethodBinding<? extends T> providesMethodBinding);
}
